#include "stdafx.h"
#include "inputclass.h"
#include "graphicsclass.h"
#include "timerclass.h"
#include "systemclass.h"


SystemClass::SystemClass()
{
}


SystemClass::SystemClass(const SystemClass& other)
{
}


SystemClass::~SystemClass()
{
}


bool SystemClass::Initialize()
{
	//  â ,    ʱȭ
	int screenWidth = 0;
	int screenHeight = 0;

	//   ʱȭ
	InitializeWindows(screenWidth, screenHeight);

	// m_Input ü .  Ŭ   Ű Է ó ˴ϴ.
	m_Input = new InputClass;
	if (!m_Input)
	{
		return false;
	}

	// m_Input ü ʱȭ
	m_Input->Initialize();

	// m_Graphics ü .  ׷  óϱ  üԴϴ.
	m_Graphics = new GraphicsClass;
	if (!m_Graphics)
	{
		return false;
	}

	// m_Graphics ü ʱȭ.
	if(!m_Graphics->Initialize(screenWidth, screenHeight, m_hwnd))
	{
		return false;
	}

	// Create the timer object.
	m_Timer = new TimerClass;
	if(!m_Timer)
	{
		return false;
	}

	// Initialize the timer object.
	if(!m_Timer->Initialize())
	{
		MessageBox(m_hwnd, L"Could not initialize the Timer object.", L"Error", MB_OK);
		return false;
	}
	return true;
}


void SystemClass::Shutdown()
{
	// Release the timer object.
	if(m_Timer)
	{
		delete m_Timer;
		m_Timer = 0;
	}
	
	// m_Graphics ü ȯ
	if (m_Graphics)
	{
		m_Graphics->Shutdown();
		delete m_Graphics;
		m_Graphics = 0;
	}

	// m_Input ü ȯ
	if (m_Input)
	{
		delete m_Input;
		m_Input = 0;
	}

	// Window  ó
	ShutdownWindows();
}


void SystemClass::Run()
{
	// ޽ ü   ʱȭ
	MSG msg;
	ZeroMemory(&msg, sizeof(MSG));

	// ڷκ  ޽  ޽ ϴ
	while (true)
	{
		//  ޽ óմϴ
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			//  ޽   ޽  Żմϴ
			if (msg.message == WM_QUIT)
				break;

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			//  ܿ Frame Լ óմϴ.
			if (!Frame())
				break;
		}
	}
}


bool SystemClass::Frame()
{
	// Update the system stats.
	m_Timer->Frame();
	
	// ESC Ű    θ óմϴ
	if (m_Input->IsKeyDown(VK_ESCAPE))
	{
		return false;
	}

	// ׷ ü Frame óմϴ
	return m_Graphics->Frame(m_Timer->GetTime());
}


LRESULT CALLBACK SystemClass::MessageHandler(HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam)
{
	switch (umsg)
	{
		// Ű尡 ° ó
	case WM_KEYDOWN:
	{
		// Ű  flag m_Input ü óϵ մϴ
		m_Input->KeyDown((unsigned int)wparam);
		return 0;
	}

	// Ű尡 ° ó
	case WM_KEYUP:
	{
		// Ű  flag m_Input ü óϵ մϴ.
		m_Input->KeyUp((unsigned int)wparam);
		return 0;
	}

	//    ޽ ⺻ ޽ ó ѱϴ.
	default:
	{
		return DefWindowProc(hwnd, umsg, wparam, lparam);
	}
	}
}


void SystemClass::InitializeWindows(int& screenWidth, int& screenHeight)
{
	// ܺ ͸  ü մϴ
	ApplicationHandle = this;

	//  α׷ νϽ ɴϴ
	m_hinstance = GetModuleHandle(NULL);

	// α׷ ̸ մϴ
	m_applicationName = L"Dx11Demo_39";

	// windows Ŭ Ʒ  մϴ.
	WNDCLASSEX wc;
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = m_hinstance;
	wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wc.hIconSm = wc.hIcon;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = m_applicationName;
	wc.cbSize = sizeof(WNDCLASSEX);

	// windows class մϴ
	RegisterClassEx(&wc);

	//  ȭ ػ󵵸 оɴϴ
	screenWidth = GetSystemMetrics(SM_CXSCREEN);
	screenHeight = GetSystemMetrics(SM_CYSCREEN);

	int posX = 0;
	int posY = 0;

	// FULL_SCREEN    ȭ մϴ.
	if (FULL_SCREEN)
	{
		// Ǯũ  ߴٸ  ȭ ػ󵵸 ũ ػ󵵷 ϰ  32bit մϴ.
		DEVMODE dmScreenSettings;
		memset(&dmScreenSettings, 0, sizeof(dmScreenSettings));
		dmScreenSettings.dmSize = sizeof(dmScreenSettings);
		dmScreenSettings.dmPelsWidth = (unsigned long)screenWidth;
		dmScreenSettings.dmPelsHeight = (unsigned long)screenHeight;
		dmScreenSettings.dmBitsPerPel = 32;
		dmScreenSettings.dmFields = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT;

		// Ǯũ ÷  մϴ.
		ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN);
	}
	else
	{
		//    800 * 600 ũ⸦ մϴ.
		screenWidth = 800;
		screenHeight = 600;

		//  â ,     մϴ.
		posX = (GetSystemMetrics(SM_CXSCREEN) - screenWidth) / 2;
		posY = (GetSystemMetrics(SM_CYSCREEN) - screenHeight) / 2;
	}

	// 츦 ϰ ڵ մϴ.
	m_hwnd = CreateWindowEx(WS_EX_APPWINDOW, m_applicationName, m_applicationName,
		WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_POPUP,
		posX, posY, screenWidth, screenHeight, NULL, NULL, m_hinstance, NULL);

	// 츦 ȭ鿡 ǥϰ Ŀ մϴ
	ShowWindow(m_hwnd, SW_SHOW);
	SetForegroundWindow(m_hwnd);
	SetFocus(m_hwnd);
}


void SystemClass::ShutdownWindows()
{
	// Ǯũ 忴ٸ ÷  ʱȭմϴ.
	if (FULL_SCREEN)
	{
		ChangeDisplaySettings(NULL, 0);
	}

	// â մϴ
	DestroyWindow(m_hwnd);
	m_hwnd = NULL;

	// α׷ νϽ մϴ
	UnregisterClass(m_applicationName, m_hinstance);
	m_hinstance = NULL;

	// ܺ  ʱȭմϴ
	ApplicationHandle = NULL;
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT umessage, WPARAM wparam, LPARAM lparam)
{
	switch (umessage)
	{
		//  Ḧ Ȯմϴ
	case WM_DESTROY:
	{
		PostQuitMessage(0);
		return 0;
	}

	// 찡  Ȯմϴ
	case WM_CLOSE:
	{
		PostQuitMessage(0);
		return 0;
	}

	//    ޽ ý Ŭ ޽ ó ѱϴ.
	default:
	{
		return ApplicationHandle->MessageHandler(hwnd, umessage, wparam, lparam);
	}
	}
}